/*
 *  userfn.h
 *
 *  Yazoo
 *  Copyright (C) 2006 Brian C. Ross
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of the License, or any later version.

 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 *  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */


#ifndef UserFunctions_h
#define UserFunctions_h



// Comment out the following line if Yazoo is to be used as an API
// (i.e. its own main() function is not needed).

#define YazooMainProgram



// Keep these include files

#include "yazooh.h"



// The required type of user-defined C or C++ functions

typedef struct {
    const char *FunctionName;
    int(*FunctionPtr)(int, char **);
} UserFunction;


// arg_info:  a data type for the final argv parameter to each user function call.
// This gives a report on the sizes, etc. of each argument.

typedef struct {
    Ulong arg_type;
    Ulong arg_size;
    Ulong arg_indices;
} arg_info;



extern UserFunction UserFunctionSet[];
extern const Ulong UF_Top;


extern int Debug(int, char **);




#endif

