/*
 *  yzmain.h
 *
 *  Yazoo
 *  Copyright (C) 2005 Brian C. Ross
 *
 *  This program is free software; you can redistribute it and/or modify it under the terms of the GNU General Public License
 *  as published by the Free Software Foundation; either version 2 of the License, or any later version.

 *  This program is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty
 *  of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU General Public License for more details.

 *  You should have received a copy of the GNU General Public License along with this program; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef Main_h
#define Main_h


#include "yazooh.h"



// Prototypes

extern int run_yazoo(int, char **);
extern int yz_main(int, char **);


// All the following is used by the author for testing

// #define YazooTest_ON    /* this line should be commented or nothing will work */


#ifdef YazooTest_ON     /* for debugging */

extern Boolean debug_on;
extern void test_MM_CountRefs();


// from TestInterpret.c

typedef struct {
    Ulong data;
    Ulong index;
    long *dataPtr;
    Ulong refs;
} TestPLLType;

typedef struct {
    Ulong *ref_ptr;
    Ulong man_refs;
    Ulong auto_refs;
} TestVarType;

typedef struct {
    void *ptr;
    Ulong refs;
} TestRefType;

#endif


#endif
